package com.idea.buildManage.service;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.io.IoUtil;
import cn.hutool.core.util.RandomUtil;
import cn.hutool.poi.excel.ExcelUtil;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.excel.write.metadata.fill.FillConfig;
import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.idea.buildManage.constant.ConstantNodeType;
import com.idea.buildManage.excel.MnpBuildingExcel;
import com.idea.buildManage.excel.ParkRoomExcel;
import com.idea.buildManage.excel.WriteHandlerStrategy;
import com.idea.buildManage.mapper.ParkRoomExtendMapper;
import com.idea.buildManage.mapper.ParkRoomMapper;
import com.idea.buildManage.model.*;
import com.idea.buildManage.response.ParkRoomResponse;
import com.idea.buildManage.vo.ParkRoomHistory;
import com.idea.buildManage.vo.ParkRoomNode;
import com.idea.buyingMore.mapper.BuyingMoreMapper;
import com.idea.buyingMore.model.BuyingMore;
import com.idea.buyingMore.model.BuyingMoreExample;
import com.idea.customerManagement.mapper.BuyerMapper;
import com.idea.customerManagement.mapper.ContractManageMapper;
import com.idea.customerManagement.mapper.CustomerManagementMapper;
import com.idea.customerManagement.mapper.RoomSelectionInfoMapper;
import com.idea.customerManagement.model.*;
import com.idea.invoice.mapper.InvoiceManageMapper;
import com.idea.invoice.model.InvoiceManage;
import com.idea.invoice.model.InvoiceManageExample;
import com.idea.invoice.util.InvoiceUtil;
import com.idea.paymentManagement.mapper.PayLogMapper;
import com.idea.paymentManagement.mapper.RefundManageMapper;
import com.idea.paymentManagement.model.PayLog;
import com.idea.paymentManagement.model.PayLogExample;
import com.idea.paymentManagement.model.RefundManage;
import com.idea.paymentManagement.model.RefundManageExample;
import com.idea.saleManage.mapper.CheckInMapper;
import com.idea.saleManage.mapper.PropertyRegistrationMapper;
import com.idea.saleManage.model.CheckIn;
import com.idea.saleManage.model.CheckInExample;
import com.idea.saleManage.model.PropertyRegistration;
import com.idea.saleManage.model.PropertyRegistrationExample;
import com.idea.util.DateUtils;
import com.rockstar.common.base.BaseService;
import com.rockstar.common.conf.V2Config;
import com.rockstar.common.support.Convert;
import com.rockstar.frame.mapper.FrameDataMapper;
import com.rockstar.frame.model.FrameData;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.shiro.util.ShiroUtils;
import com.rockstar.system.service.SysDictService;
import com.rockstar.util.SnowflakeIdWorker;
import com.rockstar.util.StringUtils;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletResponse;
import java.beans.Transient;
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.*;

@Slf4j
@Service
public class ParkRoomService implements BaseService<ParkRoom, ParkRoomExample> {

    //文件mapper
    @Autowired
    private SysDictService dictService;
    @Autowired
    private ParkRoomMapper modelMapper;
    @Autowired
    private FrameDataMapper frameDataMapper;
    @Autowired
    private ParkRoomExtendMapper extendMapper;
    @Autowired
    private RoomSelectionInfoMapper roomSelectionInfoMapper;
    @Autowired
    private MnpBuildingService buildingService;
    @Autowired
    private ParkFloorDiscService floorDiscService;
    @Autowired
    private ParkInfoService parkInfoService;
    @Autowired
    private ContractManageMapper contractManageMapper;
    @Autowired
    private CustomerManagementMapper customerManagementMapper;
    @Autowired
    private InvoiceManageMapper invoiceManageMapper;
    @Autowired
    private CheckInMapper checkInMapper;
    @Autowired
    private PropertyRegistrationMapper propertyRegistrationMapper;
    @Autowired
    private BuyingMoreMapper buyingMoreMapper;
    @Autowired
    private RefundManageMapper refundManageMapper;
    @Autowired
    private PayLogMapper payLogMapper;


    /**
     * 分页查询
     *
     * @return
     */
    public PageInfo<ParkRoom> list(Tablepar tablepar, ParkRoom model, DateTrans dt) {
        PageHelper.startPage(tablepar.getPageNum(), tablepar.getPageSize());
        List<ParkRoom> list = modelMapper.selectByExample(getCondition(model, dt));
        PageInfo<ParkRoom> pageInfo = new PageInfo<>(list);
        return pageInfo;
    }

    /**
     * 查询指定
     *
     * @return
     */
    public List<ParkRoom> listAll(ParkRoom model, DateTrans dt) {
        return modelMapper.selectByExample(getCondition(model, dt));
    }

    private ParkRoomExample getCondition(ParkRoom model, DateTrans dt) {
        ParkRoomExample ex = new ParkRoomExample();
        ex.setOrderByClause("order_num asc");
        ParkRoomExample.Criteria criteria = ex.createCriteria();
        if (StringUtils.isNotEmpty(model.getBuildId())) {
            criteria.andBuildIdEqualTo(model.getBuildId());
        }
        return ex;
    }

    @Override
    public int deleteByPrimaryKey(String ids) {
        List<String> lista = Convert.toListStrArray(ids);
        ParkRoomExample example = new ParkRoomExample();
        example.createCriteria().andIdIn(lista);
        return modelMapper.deleteByExample(example);
    }

    @Override
    public ParkRoom selectByPrimaryKey(String id) {
        return modelMapper.selectByPrimaryKey(id);
    }

    @Override
    public int updateByPrimaryKeySelective(ParkRoom record) {
        record.setUpdatedAt(new Date());
        return modelMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public int updateByExampleSelective(ParkRoom record, ParkRoomExample example) {
        record.setUpdatedAt(new Date());
        return modelMapper.updateByExampleSelective(record, example);
    }

    @Override
    public int updateByExample(ParkRoom record, ParkRoomExample example) {
        record.setUpdatedAt(new Date());
        return modelMapper.updateByExample(record, example);
    }

    @Override
    public List<ParkRoom> selectByExample(ParkRoomExample example) {
        return modelMapper.selectByExample(example);
    }

    @Override
    public long countByExample(ParkRoomExample example) {
        return modelMapper.countByExample(example);
    }

    public long countByExample(ParkRoom model, DateTrans dt) {
        return modelMapper.countByExample(getCondition(model, dt));
    }

    @Override
    public int deleteByExample(ParkRoomExample example) {
        return modelMapper.deleteByExample(example);
    }

    public int insert(ParkRoom record) {

        record.setId(SnowflakeIdWorker.getUUID());
        return insertWithoutId(record);
    }

    public int edit(ParkRoom model) {

        model.setUpdatedAt(new Date());
        model.setUpdatedId(ShiroUtils.getUserId());
//        try {
//            ParkRoom parkRoom = selectByPrimaryKey(model.getId());
//            JSONObject json = new JSONObject();
//            json.put("ncid", parkRoom.getNcid());
//            json.put("code", parkRoom.getNcCode());
//            json.put("name", parkRoom.getRoomNo());
//            log.info("推送房间修改详情:{}", json.toJSONString());
//            // 给nc推送修改载体数据
//            InvoiceUtil.defdocUpdate(json);
//        }catch (Exception e){
//            log.error("推送修改房间失败",e);
//        }
        return updateByPrimaryKeySelective(model);
    }

    public int insertWithoutId(ParkRoom record) {
        record.setCreatedAt(new Date());
        return modelMapper.insert(record);
    }

    @Override
    public int insertSelective(ParkRoom record) {
        record.setId(SnowflakeIdWorker.getUUID());
        record.setCreatedAt(new Date());
        return modelMapper.insertSelective(record);
    }

    /**
     * 分页查询
     *
     * @return
     */
    public PageInfo<ParkRoomResponse> listByModel(Tablepar tablepar, ParkRoomResponse model, DateTrans dt) {
        PageHelper.startPage(tablepar.getPageNum(), tablepar.getPageSize());
        List<ParkRoomResponse> list = extendMapper.selectByModel(model);
        PageInfo<ParkRoomResponse> pageInfo = new PageInfo<>(list);
        return pageInfo;
    }

    /**
     * 分页查询
     *
     * @return
     */
    public List<ParkRoomResponse> excelList(ParkRoomResponse model, DateTrans dt) {
        List<ParkRoomResponse> list = extendMapper.selectByModel(model);
        return list;
    }


    // 获取房屋面积
    public Double getAreaByIds(String ids) {

        List<String> idList = Arrays.asList(ids.split(","));
        ParkRoomExample example = new ParkRoomExample();
        example.createCriteria().andIdIn(idList);
        List<ParkRoom> parkRooms = modelMapper.selectByExample(example);
        BigDecimal area = new BigDecimal("0");

        return area.doubleValue();
    }

    /**
     * 批量插入
     *
     * @param list
     */
    public void insertBatch(List<ParkRoom> list) {
        extendMapper.insertBatch(list);
    }

    public int delete(String id) {

        // 已收取 已转 的定金
        List<Integer> status = Arrays.asList(2, 3);
        RoomSelectionInfoExample example = new RoomSelectionInfoExample();
        example.createCriteria().andHouseIdEqualTo(id).andStatusIn(status);
        List<RoomSelectionInfo> list = roomSelectionInfoMapper.selectByExample(example);
        if (CollectionUtils.isNotEmpty(list)) {
            throw new RuntimeException("该房间已收取认购金，无法删除");
        }
        return deleteByPrimaryKey(id);
    }

    /**
     * 查询房屋全称
     *
     * @param houseId
     * @return
     */
    public ParkRoomResponse getFullName(String houseId) {
        ParkRoomResponse response = extendMapper.getFullName(houseId);
        return response;
    }

    public String getOrderNum(ParkRoom model) {
        ParkRoomExample example = new ParkRoomExample();
        example.createCriteria().andBuildIdEqualTo(model.getBuildId());
        Long count = countByExample(example);
        String number = "";
        if (count.doubleValue() == 0) {
            number = "001";
        } else {
            count++;
            number = String.format("%03d", count);
        }
        return number;
    }

    public void errorListExport(List<ParkRoomExcel> list, HttpServletResponse response) throws IOException {


        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String date = sdf.format(new Date());
        response.setContentType("application/vnd.ms-excel");
        response.setCharacterEncoding("utf-8");
        String fileName = URLEncoder.encode("失败记录" + date, "UTF-8");
        response.setHeader("Content-disposition", "attachment;filename=" + fileName + ".xlsx");

        String templateFileName = "/home/project/settleDown/tem/房间导出模板.xlsx";
        //工作薄对象
        ExcelWriter workBook = EasyExcel.write(response.getOutputStream(), ParkRoomExcel.class)
                .withTemplate(templateFileName)
                .registerWriteHandler(new WriteHandlerStrategy())
                .build();
        //工作区对象
        WriteSheet sheet = EasyExcel.writerSheet().build();
        FillConfig build = FillConfig.builder().forceNewRow(true).build();
        workBook.fill(list, build, sheet);
        workBook.finish();


    }

    /**
     * 新增房间
     *
     * @param record
     * @return
     */
    public int add(ParkRoom record) {

        String id = SnowflakeIdWorker.getUUID();
        record.setId(id);
        record.setCreatedAt(new Date());
        record.setCreatedId(ShiroUtils.getUserId());
        // 默认待售
        record.setSoldStatus(1);
        // 默认正常
        record.setSaleStatus(1);
        // 选房状态
        record.setIsChoose(0);
        String orderNum = getOrderNum(record);
        record.setOrderNum(orderNum);
        int result = insertWithoutId(record);

//        try {
//            ParkInfo parkInfo = parkInfoService.selectByPrimaryKey(record.getGroupId());
//            ParkFloorDisc parkFloorDisc = floorDiscService.selectByPrimaryKey(record.getDiscId());
//            MnpBuilding mnpBuilding = buildingService.selectByPrimaryKey(record.getBuildId());
//            String name = parkInfo.getGroupName() + "-" + parkFloorDisc.getName() + "-" + mnpBuilding.getBuildNum()
//                    + "-" + record.getRoomNo();
//            JSONObject json = new JSONObject();
//            json.put("srcsystemid", id);
//            json.put("code", id);
//            json.put("name", name);
//            json.put("pk_org", InvoiceUtil.pk_org);
//            json.put("pk_defdoclist", InvoiceUtil.pk_defdoclist_room);
//            // 给nc推送房间数据
//            String resultJson = InvoiceUtil.defdocAdd(json);
//            JSONObject jsonObject = JSONObject.parseObject(resultJson);
//            String success = jsonObject.getString("success");
//            if (success.equals("true")) {
//                JSONObject data = jsonObject.getJSONObject("data");
//                String code = data.getString("code");
//                String ncid = data.getString("ncid");
//                ParkRoom model = new ParkRoom();
//                model.setId(id);
//                model.setNcid(ncid);
//                model.setNcCode(code);
//                updateByPrimaryKeySelective(model);
//            }
//        } catch (Exception e) {
//            log.error("推送房间失败", e);
//        }
        return result;

    }

    public List<ParkRoom> selectNeedSendList() {
        return extendMapper.selectNeedSendList();
    }

    public ParkRoomResponse getById(String id) {

        return extendMapper.getById(id);
    }

    /**
     * 房源档案列表
     *
     * @param tablepar
     * @param record
     * @param dt
     * @return
     */
    public PageInfo<ParkRoomResponse> reportList(Tablepar tablepar, ParkRoomResponse record, DateTrans dt) {

        PageHelper.startPage(tablepar.getPageNum(), tablepar.getPageSize());
        List<ParkRoomResponse> list = extendMapper.reportList(record);
        PageInfo<ParkRoomResponse> pageInfo = new PageInfo<>(list);
        return pageInfo;
    }

    /**
     * 下载房间导入模板
     *
     * @param response
     * @throws IOException
     */
    public void downLoadTemplate(HttpServletResponse response) throws IOException {

        File file = new File("/home/project/settleDown/tem/房间导入模板.xlsx");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        String date = sdf.format(new Date());
        response.setContentType("application/vnd.ms-excel");
        response.setCharacterEncoding("utf-8");
        String fileName = URLEncoder.encode("房间导入模板" + date, "UTF-8");
        response.setHeader("Content-disposition", "attachment;filename=" + fileName + ".xlsx");
        OutputStream out = response.getOutputStream();
        IoUtil.copy(FileUtil.getInputStream(file), out);
        out.close();
    }

    /**
     * 房间历史
     *
     * @param houseId
     * @return
     */
    public Map<Integer, ParkRoomHistory> roomHistory(String houseId) {


        Map<Integer, ParkRoomHistory> result = new HashMap<>();
        // 先从认购金开始查询
        RoomSelectionInfoExample roomSelectionInfoExample = new RoomSelectionInfoExample();
        roomSelectionInfoExample.setOrderByClause("collection_time asc");
        roomSelectionInfoExample.createCriteria().andHouseIdEqualTo(houseId).andStatusNotEqualTo(1);
        List<RoomSelectionInfo> list = roomSelectionInfoMapper.selectByExample(roomSelectionInfoExample);
        int order = 1;
        for (RoomSelectionInfo roomSelectionInfo : list) {

            ParkRoomHistory parkRoomHistory = new ParkRoomHistory();
            List<ParkRoomNode> parkRoomNodes = new ArrayList<>();
            ParkRoomNode parkRoomNode = new ParkRoomNode();
            parkRoomNode.setNodeName("认购");
            parkRoomNode.setBusinessId(roomSelectionInfo.getId());
            parkRoomNode.setBusinessType(ConstantNodeType.BUSINESS_TYPE_1);
            parkRoomNode.setOrderNum(order);
            parkRoomNode.setCustomerManagementId(roomSelectionInfo.getCustomerManagementId());
            parkRoomNode.setHandleDate(roomSelectionInfo.getCollectionTime());
            parkRoomNodes.add(parkRoomNode);
            parkRoomHistory.setParkRoomNodes(parkRoomNodes);
            result.put(order, parkRoomHistory);
            order++;
        }
        for (Integer key : result.keySet()) {
            ParkRoomHistory parkRoomHistory = result.get(key);
            if (parkRoomHistory != null) {
                List<ParkRoomNode> parkRoomNodes = parkRoomHistory.getParkRoomNodes();
                String customerManagementId = parkRoomNodes.get(0).getCustomerManagementId();
                CustomerManagement customerManagement = customerManagementMapper.selectByPrimaryKey(customerManagementId);
                String buyerName = customerManagement.getBuyerName();
                parkRoomHistory.setBuyerName(buyerName);
                ParkRoomNode parkRoomNode;
                // 查询合同 查询预付款
                ContractManageExample contractManageExample = new ContractManageExample();
                contractManageExample.createCriteria().andCustomerManagementIdEqualTo(customerManagementId)
                        .andHouseIdEqualTo(houseId)
                        .andContractStatusNotEqualTo(1);
                List<ContractManage> contractManages = contractManageMapper.selectByExample(contractManageExample);
                if (CollectionUtils.isNotEmpty(contractManages)) {

                    ContractManage contractManage = contractManages.get(0);
                    Date signingDate = contractManage.getSigningDate();

                    parkRoomNode = new ParkRoomNode();
                    parkRoomNode.setNodeName("签约");
                    parkRoomNode.setBusinessType(ConstantNodeType.BUSINESS_TYPE_2);
                    parkRoomNode.setOrderNum(2);
                    if (signingDate != null) {
                        parkRoomNode.setHandleDate(contractManage.getSigningDate());
                    }
                    parkRoomNodes.add(parkRoomNode);

                    // 查询预收款 收款时间
                    PayLogExample payLogExample = new PayLogExample();
                    payLogExample.createCriteria()
                            .andContentTypeNotEqualTo(7).andContractIdEqualTo(contractManage.getId())
                            .andStatusEqualTo(0).andPayTypeEqualTo(1);
                    List<PayLog> payLogs = payLogMapper.selectByExample(payLogExample);
                    Optional<Date> max = payLogs.stream().map(PayLog::getPayTime).max(Date::compareTo);
                    Date date = max.orElse(null);
                    parkRoomNode = new ParkRoomNode();
                    parkRoomNode.setNodeName("预付款");
                    parkRoomNode.setBusinessType(ConstantNodeType.BUSINESS_TYPE_3);
                    parkRoomNode.setOrderNum(3);
                    if(date != null){
                        parkRoomNode.setHandleDate(date);
                    }
                    parkRoomNodes.add(parkRoomNode);
                }
                // 查询开票
                InvoiceManageExample invoiceManageExample = new InvoiceManageExample();
                invoiceManageExample.createCriteria().andCustomerManagementIdEqualTo(customerManagementId);
                List<InvoiceManage> invoiceManages = invoiceManageMapper.selectByExample(invoiceManageExample);
                if (CollectionUtils.isNotEmpty(invoiceManages)) {

                    //查询最大开票时间
                    Optional<InvoiceManage> max = invoiceManages.stream().filter(item->item.getInvoiceDate() !=null)
                            .max(Comparator.comparing(InvoiceManage::getInvoiceDate));
                    InvoiceManage invoiceManage = max.orElse(null);
                    parkRoomNode = new ParkRoomNode();
                    parkRoomNode.setNodeName("开票");
                    parkRoomNode.setBusinessType(ConstantNodeType.BUSINESS_TYPE_4);
                    parkRoomNode.setOrderNum(4);
                    if(invoiceManage != null){
                        parkRoomNode.setHandleDate(invoiceManage.getInvoiceDate());
                    }
                    parkRoomNodes.add(parkRoomNode);
                }

                // 查询入住 产权 增购回购
                if (CollectionUtils.isNotEmpty(contractManages)) {
                    String contractId = contractManages.get(0).getId();

                    // 查询入住
                    CheckInExample checkInExample = new CheckInExample();
                    checkInExample.createCriteria().andContractManageIdEqualTo(contractId);
                    List<CheckIn> checkIns = checkInMapper.selectByExample(checkInExample);
                    if (CollectionUtils.isNotEmpty(checkIns)) {

                        Date inDate = checkIns.get(0).getInDate();
                        parkRoomNode = new ParkRoomNode();
                        parkRoomNode.setNodeName("入驻");
                        parkRoomNode.setBusinessType(ConstantNodeType.BUSINESS_TYPE_5);
                        parkRoomNode.setOrderNum(5);
                        parkRoomNode.setHandleDate(inDate);
                        parkRoomNodes.add(parkRoomNode);
                    }

                    // 查询产权
                    PropertyRegistrationExample propertyRegistrationExample = new PropertyRegistrationExample();
                    propertyRegistrationExample.createCriteria().andContractManageIdEqualTo(contractId);
                    List<PropertyRegistration> propertyRegistrations = propertyRegistrationMapper.selectByExample(propertyRegistrationExample);
                    if (CollectionUtils.isNotEmpty(propertyRegistrations)) {

                        Date operateTime = propertyRegistrations.get(0).getOperateTime();
                        parkRoomNode = new ParkRoomNode();
                        parkRoomNode.setNodeName("产权");
                        parkRoomNode.setBusinessType(ConstantNodeType.BUSINESS_TYPE_6);
                        parkRoomNode.setOrderNum(6);
                        parkRoomNode.setHandleDate(operateTime);
                        parkRoomNodes.add(parkRoomNode);
                    }

                    // 查询增购回购
                    BuyingMoreExample buyingMoreExample = new BuyingMoreExample();
                    buyingMoreExample.createCriteria().andContractIdEqualTo(contractId);
                    List<BuyingMore> buyingMores = buyingMoreMapper.selectByExample(buyingMoreExample);
                    if (CollectionUtils.isNotEmpty(buyingMores)) {

                        Optional<BuyingMore> max = buyingMores.stream().max(Comparator.comparing(BuyingMore::getSigningDate));
                        BuyingMore buyingMore = max.orElse(null);

                        parkRoomNode = new ParkRoomNode();
                        parkRoomNode.setNodeName("回购/增购");
                        parkRoomNode.setBusinessType(ConstantNodeType.BUSINESS_TYPE_7);
                        parkRoomNode.setOrderNum(7);
                        if(buyingMore != null){
                            parkRoomNode.setHandleDate(buyingMore.getSigningDate());
                        }
                        parkRoomNodes.add(parkRoomNode);
                    }

                }

                // 查询退房
                RefundManageExample refundManageExample = new RefundManageExample();
                refundManageExample.createCriteria().andHouseIdEqualTo(houseId);
                List<RefundManage> refundManages = refundManageMapper.selectByExample(refundManageExample);
                if (CollectionUtils.isNotEmpty(refundManages)) {

                    Date createdAt = refundManages.get(0).getCreatedAt();
                    parkRoomNode = new ParkRoomNode();
                    parkRoomNode.setNodeName("回购/增购");
                    parkRoomNode.setBusinessType(ConstantNodeType.BUSINESS_TYPE_7);
                    parkRoomNode.setOrderNum(7);
                    parkRoomNode.setHandleDate(createdAt);
                    parkRoomNodes.add(parkRoomNode);
                }

            }


        }

        String startDate = "";
        String endDate = "";
        // 排序
        for (Integer key : result.keySet()) {
            ParkRoomHistory parkRoomHistory = result.get(key);
            List<ParkRoomNode> parkRoomNodes = parkRoomHistory.getParkRoomNodes();
            Optional<ParkRoomNode> max = parkRoomNodes.stream().filter(item -> item.getHandleDate() != null)
                    .max(Comparator.comparing(ParkRoomNode::getHandleDate));
            ParkRoomNode parkRoomNode = max.orElse(null);
            if (parkRoomNode != null) {
                endDate = DateUtils.parseDateToStr("yyyy-MM-dd HH:mm",parkRoomNode.getHandleDate());
            }
            Date handleDate = parkRoomNodes.get(0).getHandleDate();
            startDate = DateUtils.parseDateToStr("yyyy-MM-dd HH:mm",handleDate);
            parkRoomHistory.setStartDate(startDate);
            parkRoomHistory.setEndDate(endDate);
        }

        return result;
    }


}
