package com.idea.buyingMore.controller;

import com.github.pagehelper.PageInfo;
import com.idea.buyingMore.dto.BuyingMoreDto;
import com.idea.buyingMore.model.BuyingMore;
import com.idea.buyingMore.service.BuyingMoreService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;


@Controller
@RequestMapping(value = "BuyingMoreController")
@Api(tags = "增购管理")
public class BuyingMoreController extends BaseController {

    @Autowired
    private BuyingMoreService modelService;

    @ApiOperation(value = "新增增购")
    @PostMapping(value = "add", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(BuyingMore record) {

        int result = modelService.add(record);
        return result(result);
    }

    @ApiOperation(value = "编辑增购")
    @PostMapping(value = "edit", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult edit(BuyingMore record) {

        int result = modelService.edit(record);
        return result(result);
    }

    @ApiOperation(value = "删除增购")
    @PostMapping(value = "delete", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult delete(String id) {

        int result = modelService.delete(id);
        return result(result);
    }


    @PostMapping(value = "list", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, BuyingMoreDto model, DateTrans dt) {
        PageInfo<BuyingMoreDto> page = modelService.list(tablepar, model, dt);
        TableSplitResult<BuyingMoreDto> result = new TableSplitResult<BuyingMoreDto>(page.getPageNum(), page.getTotal(), page.getList());
        return result;
    }

    @ApiOperation(value = "房间列表")
    @PostMapping(value = "listAll", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object listAll(BuyingMore model, DateTrans dt) {
        return modelService.listAll(model, dt);
    }


    @ApiOperation(value = "获取合同信息")
    @PostMapping(value = "getByContractId", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getByContractId(String contractId){
        return modelService.getByContractId(contractId);
    }

    @ApiOperation(value = "根据id查询")
    @PostMapping(value = "getById", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getById(String id) {
        return modelService.getById(id);
    }

}
