package com.idea.oa.flow2.mapper;

import com.idea.oa.flow2.model.FlowMainPush;
import com.idea.oa.flow2.model.out.FlowMainPushOut;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Component;

import java.util.List;
@Component
public interface FlowMainPushExtendMapper {
    @Select("UPDATE flow_main_push SET STATUS=2,updated_by=#{userId},updated_at=NOW() WHERE flow_main_push.up_main_log_id=#{upMainLogId} AND flow_main_push.id !=#{id} and status=0")
    void updateStatusTwoByUpMainLogId(@Param("userId") String userId,@Param("upMainLogId") String upMainLogId,@Param("id") String id);
    @Select("UPDATE flow_main_push SET STATUS=3,updated_by=#{userId},updated_at=NOW() WHERE flow_main_push.flow_main_id=#{flowMainId} and STATUS=0")
    void updateStatusThreeByFlowMainId(@Param("userId") String userId,@Param("flowMainId")  String flowMainId);

    @Select("SELECT frame_user.truename AS pushUserName,flow_main_push.*FROM flow_main_push LEFT JOIN frame_user ON frame_user.id=flow_main_push.push_user WHERE flow_main_push.flow_main_id=#{flowMainid} AND flow_main_push.STATUS=0")
    List<FlowMainPushOut> findPushInfoByFlowMainId(String flowMainid);


    @Select("SELECT flow_main_push.*FROM flow_main_push  WHERE flow_main_push.flow_main_id=#{flowMainid} AND flow_main_push.STATUS=0")
    List<FlowMainPush> findPushByFlowMainId(String flowMainid);
}