package com.idea.paymentManagement.controller;

import com.github.pagehelper.PageInfo;
import com.idea.buildManage.response.ParkRoomResponse;
import com.idea.paymentManagement.dto.RefundManageDto;
import com.idea.paymentManagement.service.RefundManageService;
import com.rockstar.common.base.BaseController;
import com.rockstar.common.domain.AjaxResult;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.TableSplitResult;
import com.rockstar.frame.model.extend.Tablepar;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

@Controller
@RequestMapping(value = "RefundManageController")
@Api(tags = "退款管理")
public class RefundManageController extends BaseController {

    @Autowired
    private RefundManageService modelService;

    /**
     * 根据身份证号带出关联房屋
     *
     * @param identityCard
     * @return
     */
    @PostMapping(value = "getHouseListByIdCard", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public List<ParkRoomResponse> getHouseListByIdCard(String identityCard) {

        List<ParkRoomResponse> result = modelService.getHouseListByIdCard(identityCard);
        return result;
    }

    @PostMapping(value = "getById", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object getById(String id) {
        return modelService.getById(id);
    }

    /**
     * 新增退款
     *
     * @param model
     * @return
     */
    @PostMapping(value = "add", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult add(RefundManageDto model) {
        int result = modelService.add(model);
        return result(result);
    }


    /**
     * 编辑退款
     *
     * @param model
     * @return
     */
    @PostMapping(value = "edit", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public AjaxResult edit(RefundManageDto model) {
        int result = modelService.edit(model);
        return result(result);
    }


    @PostMapping(value = "list", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(Tablepar tablepar, RefundManageDto model, DateTrans dt) {
        PageInfo<RefundManageDto> page = modelService.listByModel(tablepar, model, dt);
        TableSplitResult<RefundManageDto> result = new TableSplitResult<RefundManageDto>(page.getPageNum(), page.getTotal(), page.getList());
        return result;
    }

    @PostMapping(value = "listAll", produces = {"application/json;charset=UTF-8"})
    @ResponseBody
    public Object list(RefundManageDto model) {
        List<RefundManageDto> result = modelService.listAll(model);
        return result;
    }


}
