package com.idea.saleManage.service;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

import com.idea.customerManagement.mapper.CustomerManagementMapper;
import com.idea.customerManagement.model.CustomerManagement;
import com.idea.saleManage.mapper.CheckInMapper;
import com.idea.saleManage.model.CheckIn;
import com.idea.saleManage.model.CheckInExample;
import com.idea.saleManage.model.CheckInMore;
import com.rockstar.common.base.BaseService;
import com.rockstar.common.support.Convert;
import com.rockstar.frame.model.extend.DateTrans;
import com.rockstar.frame.model.extend.Tablepar;
import com.rockstar.util.DateUtils;
import com.rockstar.util.StringUtils;
import com.rockstar.util.UUIDUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class CheckInService implements BaseService<CheckIn, CheckInExample> {

    //文件mapper
    @Autowired
    private CheckInMapper modelMapper;
    @Autowired
    private CustomerManagementMapper customerManagementMapper;

    /**
     * 分页查询
     *
     * @return
     */
    public PageInfo<CheckInMore> list(Tablepar tablepar, CheckInMore model, DateTrans dt) {
        PageHelper.startPage(tablepar.getPageNum(), tablepar.getPageSize());
        List<CheckInMore> list =modelMapper.findList(model);
        PageInfo<CheckInMore> pageInfo = new PageInfo<>(list);
        return pageInfo;
    }

   public Object listAll(CheckInMore model, DateTrans dt) {
        List<CheckInMore> list = modelMapper.findList(model);
        return list;
    }




    @Override
    public int deleteByPrimaryKey(String ids) {
        List<String> lista = Convert.toListStrArray(ids);
        CheckInExample example = new CheckInExample();
        example.createCriteria().andIdIn(lista);
        return modelMapper.deleteByExample(example);
    }

    @Override
    public CheckIn selectByPrimaryKey(String id) {
        return modelMapper.selectByPrimaryKey(id);
    }

    @Override
    public int updateByPrimaryKeySelective(CheckIn record) {
        return modelMapper.updateByPrimaryKeySelective(record);
    }

    public int updateByPrimaryKey(CheckIn record) {
        return modelMapper.updateByPrimaryKey(record);
    }
    @Override
    public int updateByExampleSelective(CheckIn record, CheckInExample example) {
        return modelMapper.updateByExampleSelective(record, example);
    }

    @Override
    public int updateByExample(CheckIn record, CheckInExample example) {
        return modelMapper.updateByExample(record, example);
    }

    @Override
    public List<CheckIn> selectByExample(CheckInExample example) {
        return modelMapper.selectByExample(example);
    }

    @Override
    public long countByExample(CheckInExample example) {
        return modelMapper.countByExample(example);
    }


    @Override
    public int deleteByExample(CheckInExample example) {
        return modelMapper.deleteByExample(example);
    }

    public int insert(CheckIn record){
        record.setId(UUIDUtils.middleUUID());
        return insertWithoutId(record);
    }

    public int insertWithoutId(CheckIn record){
        return modelMapper.insert(record);
    }

    @Override
    public int insertSelective(CheckIn record) {
        record.setId(UUIDUtils.middleUUID());
        return modelMapper.insertSelective(record);
    }


    public int edit(CheckIn model,String customerManagementId){
        if(StringUtils.isNotEmpty(model.getStatus())){
            // 更新购房状态 已入驻
            CustomerManagement customerManagement = customerManagementMapper.selectByPrimaryKey(customerManagementId);
            customerManagement.setStatus(4);
            customerManagementMapper.updateByPrimaryKeySelective(customerManagement);
        }else {
            // 更新购房状态 已签约
            CustomerManagement customerManagement = customerManagementMapper.selectByPrimaryKey(customerManagementId);
            if(customerManagement.getStatus() == 4){
                customerManagement.setStatus(3);
            }
            customerManagement.setStatus(4);
            customerManagementMapper.updateByPrimaryKeySelective(customerManagement);
        }
        return modelMapper.updateByPrimaryKeySelective(model);
    }

}
