package com.idea.pro.wx.jwt;

import com.rockstar.util.StringUtils;
import com.rockstar.wx.util.JwtHelper;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.aspectj.lang.annotation.Pointcut;
import org.springframework.stereotype.Component;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.servlet.http.HttpServletRequest;

@Aspect
@Component
public class WxLoginAopVerify {

    @Pointcut("@annotation(com.idea.pro.wx.jwt.LoginCheck)")
    public void ouAspect() {
    }

    @Before("ouAspect()")
    public void beforeMethod(JoinPoint joinPoint) {
        ServletRequestAttributes attributes = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
        HttpServletRequest request = attributes.getRequest();
        String token = request.getHeader("Authorization");
        System.err.println("tol_:"+token);
        if(StringUtils.isNotEmpty(token)){
            if(!token.contains("Bearer"))
                throw new LoginCheckException("请求令牌不能为空！");
//            token = token.substring(token.lastIndexOf("Bearer "));
            token = token.replace("Bearer ", "");
            System.err.println("token_:"+token);
            JwtHelper jwtHelper = new JwtHelper();
            String userId = jwtHelper.verifyTokenAndGetUserId(token);
            if(!StringUtils.isNotEmpty(userId)){
                throw new LoginCheckException("您的令牌已过期！");
            }
        }else{
            throw new LoginCheckException("请求令牌不能为空！");
        }

    }

}
